import os, re, sys
from string import *

tags  = ["a","abbr","acronym","address","applet","area","b",
	"base","basefont","bdo","big","blockquote","br",
	"button","caption","center","cite","code","col","colgroup",
	"dd","del","dir","div","dfn","dl","dt","em","fieldset",
	"font","form","frame","frameset","h1","head","hr","html",
	"i","iframe","img","input","ins","isindex","kbd","label",
	"legend","li","link","map","menu","meta","noframes","noscript",
	"object","ol","optgroup","option","p","param","pre","q","s",
	"samp","script","select","small","span","strike","strong",
	"style","sub","sup","table","tbody","td","textarea","tfoot",
	"th","thead","title","tr","tt","u","ul","var","xmp"
]
spec_tags = ["audioscope","bgsound","blackface","blink","bq","comment","embed",
	"fn","ilayer","keygen","layer","limittext","listing","marquee",
	"multicol","nobr","noembed","nosmartquotes","plaintext","rt","ruby",
	"server","shadow","sidebar","spacer","wbr","xml","xmp"
]

data = {}
reg = re.compile("(.+)\t\t(.+)\t\t(.+)", re.I)

if len(sys.argv) < 3:
	print "usage: goodOutput.py [browser_name] [data file]"
else:
	[tags.append(i) for i in spec_tags if i not in tags]
	brw = sys.argv[1]
	arg = sys.argv[2]
	try:
		file = open(arg, 'r')
		for l in file.readlines():
			if reg.match(l):
				out = reg.search(l)
				event = out.group(2)
				tag   = out.group(3)
				if event not in data:
					data[event] = []
				data[event].append(tag)
		file.close()
	except IOError:
		print "Cannot open the file", arg

	for event in data:
		print event, ":"
		buf = "(%s):\t" % brw
		listTags = [i for i in tags if i not in data[event]]
		listTags.sort(lambda i,j: cmp(i,j))
		for tag in listTags:
			buf += (tag + ',')
		print buf
		print ""

