import os, sys
tags  = ['a','abbr','acronym','address','applet','area','b',
	'base','basefont','bdo','big','blockquote','br',
	'button','caption','center','cite','code','col','colgroup',
	'dd','del','dir','div','dfn','dl','dt','em','fieldset',
	'font','form','frame','frameset','h1','head','hr','html',
	'i','iframe','img','input','ins','isindex','kbd','label',
	'legend','li','link','map','menu','meta','noframes','noscript',
	'object','ol','optgroup','option','p','param','pre','q','s',
	'samp','script','select','small','span','strike','strong',
	'style','sub','sup','table','tbody','td','textarea','tfoot',
	'th','thead','title','tr','tt','u','ul','var','xmp'
]

listOfTableTags = ['col','table','colgroup','caption','thead','tfoot','tbody','tr', 'td', 'th']

table_template_1 = """
<table %s>
<colgroup %s >
	<col %s />
</colgroup>
<caption %s>
<thead %s >THEAD</thead>
<tfoot %s >TFOOT</tfoot>
<tbody %s>
	<tr %s><td %s><th %s>TR(TD(TH(FOO)))</th></td>
</tbody>
</table>
"""

def write_template_table_1(tagName, eventName):
	t = ['','','','','','','','','','','','','','']
	index = 0
	if tagName == 'table':
		index = 0
	elif tagName == 'colgroup':
		index = 1
	elif tagName == 'col':
		index = 2
	elif tagName == 'caption':
		index = 3
	elif tagName == 'thead':
		index = 4
	elif tagName == 'tfoot':
		index = 5
	elif tagName == 'tbody':
		index = 6
	elif tagName == 'tr':
		index = 7
	elif tagName == 'td':
		index = 8
	elif tagName == 'th':
		index = 9
	else:
		index = 0
	t[index] = "id='tested-object' %s=\"myFooFunction();\"" % eventName
	return table_template_1 % (t[0],t[1],t[2],t[3],t[4],t[5],t[6],t[7],t[8],t[9])


listOfFormTags = ['form','label','fieldset','input','select','optgroup','option','textarea']

form_template_1 = """
<form %s >
	<label %s for="Foo">
	<fieldset %s >
		<input %s type="text" />
	</fieldset>
	<select %s >
		<optgroup %s label="Foo">
			<option %s  value ="bar">Bar</option>
		</optgroup>
	</select>
	<textarea %s ></textarea>
</form>
"""


def write_template_form_1(tagName, eventName):
	t = ['','','','','','','','','','','','','','']
	index = 0
	if tagName == 'form':
		index = 0
	elif tagName == 'label':
		index = 1
	elif tagName == 'fieldset':
		index = 2
	elif tagName == 'input':
		index = 3
	elif tagName == 'select':
		index = 4
	elif tagName == 'optgroup':
		index = 5
	elif tagName == 'option':
		index = 6
	elif tagName == 'textarea':
		index = 7
	else:
		index = 0
	t[index] = "id='tested-object' %s=\"myFooFunction();\"" % eventName
	return form_template_1 % (t[0],t[1],t[2],t[3],t[4],t[5],t[6],t[7])


listOfFrameTags = ['frameset','frame']
frame_template_1 = """
<frameset %s cols= "*">
  <frame %s src="foo" />
</frameset>
"""

def write_template_frame_1(tagName, eventName):
	t = ['','','','','','','','','','','','','','']
	index = 0
	if tagName == 'frameset':
		index = 0
	elif tagName == 'frame':
		index = 1
	else:
		index = 0
	t[index] = "id='tested-object' %s=\"myFooFunction();\"" % eventName
	return frame_template_1 % (t[0],t[1])



listOfMapTags = ['map', 'area']
map_template_1 = """
<img src ="foo" width="145" height="126" alt="foo" usemap ="#foo" />
<map %s name="foo">
  <area %s shape="rect" coords ="0,0,82,126" href ="foo" target ="_blank" alt="foo" />
</map>
"""

def write_template_map_1(tagName, eventName):
	t = ['','','','','','','','','','','','','','']
	index = 0
	if tagName == 'map':
		index = 0
	elif tagName == 'area':
		index = 1
	else:
		index = 0
	t[index] = "id='tested-object' %s=\"myFooFunction();\"'" % eventName
	return map_template_1 % (t[0],t[1])



genericOutput_tc = """
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<script language="JavaScript" type="text/javascript" src="../../app/jsUnitCore.js"></script>
	<script language="JavaScript" type="text/javascript" src="../../detect_browser.js"></script>
	<script language="JavaScript" type="text/javascript" src="../../launcher.js"></script>
	<script language="JavaScript" type="text/javascript">
		var aVar = null;
        function testOnLoadFired() {
            assertEquals("foo", aVar);
        }
        function myFooFunction() {
            aVar = "foo";
        }
    </script>
</head>
<body onload="launch('%s')" >
%s
</body>
</html>
"""



"""
events= {
	'interface' : ['onblur','onfocus','onload','onresize','onscroll', 'onunload'],
	'form' :      ['onchange','onreset','onselect','onsubmit'],
	'mouse':      ['onclick','ondblclick','onmousedown','onmousemove','onmouseout','onmouseover','onmouseup'],
	'key'  :      ['onkeydown','onkeypress','onkeyup'],
	'mics' :      ['onerror','onabort']
}
"""

events= ['onblur','onchange','onclick','ondblclick','onfocus','onkeydown','onkeypress','onkeyup','onload','onmousedown','onmousemove','onmouseout','onmouseover','onmouseup','onreset','onselect','onsubmit','onunload']


non_std_tags = ['audioscope','bgsound','blackface','blink','bq','comment','embed','fn','ilayer','keygen','layer','limittext','listing','marquee','multicol','nobr','noembed','nosmartquotes','plaintext','rt','ruby','server','shadow','sidebar','spacer','wbr','xml','xmp']

ie_events = ['onactivate','onafterprint','onafterupdate','onbeforeactivate','onbeforecopy',
					'onbeforecut','onbeforedeactivate','onbeforeeditfocus','onbeforepaste','onbeforeprint','onbeforeunload',
					'onbeforeupdate','onbounce','oncontextmenu','oncontrolselect','oncopy','oncut','ondataavailable','ondatasetchanged',
					'ondatasetcomplete','ondeactivate','ondrag','ondragend','ondragenter','ondragleave','ondragover','ondragstart',
					'ondrop','onerrorupdate','onfilterchange','onfinish','onfocusin','onfocusout','onhelp','onlayoutcomplete',
					'onlosecapture','onmouseenter','onmouseleave','onmousewheel','onmove','onmoveend','onmovestart','onpaste',
					'onpropertychange','onreadystatechange','onresizeend','onresizestart','onrowenter','onrowexit',
					'onrowsdelete','onrowsinserted','onselectionchange','onselectstart','onstart','ontimeerror']

template = """
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<script language="JavaScript" type="text/javascript" src="../../app/jsUnitCore.js"></script>
	<script language="JavaScript" type="text/javascript" src="../../detect_browser.js"></script>
	<script language="JavaScript" type="text/javascript" src="../../launcher.js"></script>
	<script language="JavaScript" type="text/javascript">
		var aVar = null;
        function testOnLoadFired() {
            assertEquals("foo", aVar);
        }
        function myFooFunction() {
            aVar = "foo";
        }
    </script>
</head>
<body onload="launch('%s')" >
<%s id='tested-object' %s="myFooFunction();">/* Test for Tag=%s and Event=%s */</%s>
</body>
</html>
"""

testsuite_template = """
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    <title>JsUnit Test Suite</title>
    <script language="JavaScript" type="text/javascript" src="../app/jsUnitCore.js"></script>
    <script language="JavaScript" type="text/javascript">

        function coreSuite() {
            var result = new top.jsUnitTestSuite();
%s            return result;
        }

        function suite() {
            var newsuite = new top.jsUnitTestSuite();
            newsuite.addTestSuite(coreSuite());
            return newsuite;
        }
    </script>
</head>

<body>
<h1>JsUnit Test Suite</h1>
<p>This page contains a suite of tests for testing JsUnit.</p>
</body>
</html>
"""
ts_pattern = "            result.addTestPage('%s');\n"


def purify():
	global tags
	for tag in non_std_tags:
		if tag not in tags:
			tags.append(tag)

def generate(tag, path, eventList):
	try:
		os.mkdir(path)
	except OSError:
		a=1
	listPatterns = ""
	for event in eventList:
		try:
			fName = path + '/tc_'+ event +'.html'
			outFile = open(fName,'w')
			if tag not in listOfTableTags and tag not in listOfFormTags and tag not in listOfFrameTags and tag not in listOfMapTags:
				outFile.write(template % (event, tag, event, tag,event,tag))
			else:
				if tag in listOfTableTags:
					outFile.write(genericOutput_tc % (event, write_template_table_1(tag,event)))
				elif tag in listOfFormTags:
					outFile.write(genericOutput_tc % (event, write_template_form_1(tag,event)))
				elif tag in listOfFrameTags:
					outFile.write(genericOutput_tc % (event, write_template_frame_1(tag,event)))
				elif tag in listOfMapTags:
					outFile.write(genericOutput_tc % (event, write_template_map_1(tag,event)))

			outFile.close()
			listPatterns += (ts_pattern % ('./' + tag + '/tc_'+event+'.html'))
		except IOError:
			print "Error on the event = ", event, "for the tag", tag
	# create the test suite page
	try:
		ts_page = open(path + '/../' + tag + '_testsuite.html', 'w')
	except IOError:
		print "Error creating the page for the test suite; tag =", tag
	buff = testsuite_template % listPatterns
	ts_page.write(buff)
	ts_page.close()

purify()

for tag in tags:
	path = os.curdir + '/testcases/' + tag
	generate(tag, path, events)
	iep  = os.curdir + '/testcases_ie/' + tag
	generate(tag, iep, ie_events)

# create a page with every links by tags such as 'ts_onblur.html' with the JSUnit Core
s_event_path = './event_based'
gen_events = events + ie_events
pre = ''
for e in gen_events:
	if e not in ie_events:
		tc_path = 'testcases'
		pre = ''
	else:
		tc_path = 'testcases_ie'
		pre = 'ie'

	listPatterns = ""
	try:
		event_path = s_event_path + '/ts' + pre + '__' + e + '.html'
		e_testsuite = open(event_path, 'w')
		for t in tags:
			listPatterns += (ts_pattern % ('../' + tc_path + '/' + t + '/tc_' + e + '.html'))
		buff = testsuite_template % listPatterns
		e_testsuite.write(buff)
		e_testsuite.close()
	except IOError:
		print "Error creating the Test Suite page for the event: ", e

# create a global test suite
event_path ='ts_global.html'
try:
	e_testsuite = open(event_path, 'w')
	listPatterns = ""
	buff = ""
	for e in gen_events:
		if e not in ie_events:
			tc_path = 'testcases'
		else:
			tc_path = 'testcases_ie'
		event_path = s_event_path + '/ts_' + e + '.html'
		for t in tags:
			listPatterns += (ts_pattern % (tc_path + '/' + t + '/tc_' + e + '.html'))
	buff = testsuite_template % listPatterns
	e_testsuite.write(buff)
	e_testsuite.close()
except IOError:
	print "Error creating the Test Suite page for the event: ", e


